# ALFA Active DQ Sample Project 

This project shows how ALFA can be used to validate data in CSV, Avro, zipped CSV, and Spark.



## Running ALFA DQ

The following are commands used to execute DQ on the sample data files in various formats. Some files have data errors, that are expected to be pickedup during the DQ runs.

### CSV
```shell
alfa --dq --datafiles data/SalesData.csv --settings "use-cached-classes=true;exclude-asserts=ValidCountry;csv-has-header=true;csv-use-header=false"  --types Validate.SaleRecord -o ./generated model
```

### Avro

```shell
alfa --dq --datafiles data/SalesData.avro --settings "use-cached-classes=true;exclude-asserts=ValidCountry"  --types Validate.SaleRecord -o ./generated model
```


### JSON

```shell
alfa --dq --datafiles data/SalesData.json --settings "use-cached-classes=true;exclude-asserts=ValidCountry"  --types Validate.SaleRecord -o ./generated model
```


### JSONL

```shell
alfa --dq --datafiles data/SalesData.jsonl --settings "use-cached-classes=true;exclude-asserts=ValidCountry"  --types Validate.SaleRecord -o ./generated model
```


### Spark (Local execution)

Data in Spark can be validated using ALFA DQ rules. A local or cluster installation of Spark is required. 

The results of the DQ run can be written to a Spark DataFrame.

```shell
# Use local Spark install directory
export ALFA_OPT_JARS=$HOME/tools/spark-3.3.1-bin-hadoop2/jars/*
export ALFA_JVM_ARGS=--add-opens=java.base/sun.nio.ch=ALL-UNNAMED

alfa --dq --datafiles config/local.sales-recs.spark-dq.json -o ./generated model
```


### Run DQ on 1,000,000 row zipped CSV file.

```shell
alfa --dq --datafiles data/BulkSalesData.csv.zip --settings "use-cached-classes=true;exclude-asserts=ValidCountry;csv-has-header=true;csv-use-header=false"  --types Validate.SaleRecord -o ./generated model/sales
```
